#ifndef __MsgShellP_h
#define __MsgShellP_h

#include <X11/ShellP.h>
#include "MsgShell.h"

#include "msgwin.h"
#include "frame.h"
#include "msgpack.h"

typedef struct{
	XtPointer extension;
} MsgShellClassPart;

typedef struct _MsgShellClassRec{
	CoreClassPart core_class;
    CompositeClassPart composite_class;
    ShellClassPart  shell_class;
    WMShellClassPart   wm_shell_class;
    VendorShellClassPart vendor_shell_class;
    TopLevelShellClassPart top_level_shell_class;
	MsgShellClassPart msg_shell_class; 
} MsgShellClassRec;

extern MsgShellClassRec msgShellClassRec;

typedef struct _MsgShellPart {
	char *filename;
	MessageWin *msgwin;
	Frame  *frame;
	int fd;
	int fdout;
	XtIntervalId timer_id;
	XtInputId    input_id;
	XtInputId    output_id;
	MsgPacketList msglist;
	int xpos, ypos;
	int dx, dy;
	int click_x, click_y;

	Cursor cursor;
	Cursor href_cursor;

	Window *inputwindows;
	int inputwindows_num;

	Boolean hukidasi;

	/* font select information */
	FontNameList fnl;
	FontNameList fnl_fixed;

} MsgShellPart;

typedef struct _MsgShellRec {
	CorePart	core;
	CompositePart   composite;
    ShellPart   shell;
    WMShellPart wm;
    VendorShellPart vendor;
    TopLevelShellPart 	 topLevel;
	MsgShellPart msg;
} MsgShellRec;

#endif
