#include <stdio.h>
#include <stdlib.h>

#include "frame.h"
#include "image.h"

static ColorList *
colorlist_new(void)
{
	ColorList *p;
    if ((p = malloc(sizeof(*p))) == NULL) {
        perror("colorlist_new");
        exit(1);
    }
	return p;
}

static void
colorlistlist_delete(Frame *f, ColorList *p)
{
	ColorList *q;
	while(p) {
		q = p;
		XFreeColors(f->dpy, f->colormap, &p->pixel, 1, 0);
		p = p->next;
		free(p);
	}
}

void 
frame_alloc_color(Frame *f, char *name, u_long *ret)
{
	XColor scr, exact;
	XrmQuark n;
	ColorList *p;

	p = f->pixels;
	while (p != NULL) {
		if ((n = XrmStringToQuark(name)) == p->name) {
			*ret = p->pixel;
			return;
		}
		p = p->next;
	}	
	if (XAllocNamedColor(f->dpy, f->colormap, name, &scr, &exact)) {
		p = colorlist_new();
		p->name = n;
		*ret = p->pixel = scr.pixel;
		p->next = f->pixels;
		f->pixels = p;
	}
}

