#ifndef _parse_h_
#define _parse_h_

#include "frame.h"

/* parse.c */
void frame_parse(Frame *f);

/* parse_etc.c */
int parse_size(char *val, int max);
void frame_parse_align(Frame *f, Tag *tag);

/* parse_block.c */
void frame_parse_body(Frame *f, Tag *tag);
void frame_parse_heading(Frame *f, Tag *tag);
void frame_parse_p(Frame *f, Tag *tag);
void frame_parse_pre(Frame *f, Tag *tag);

void frame_parse_ul(Frame *f, Tag *tag);
void frame_parse_ol(Frame *f, Tag *tag);
void frame_parse_li(Frame *f, Tag *tag);

/* parse_mono.c */
void frame_parse_img(Frame *f, Tag *tag);
void frame_parse_hr(Frame *f, Tag *tag);
void frame_parse_basefont(Frame *f, Tag *tag);
void frame_parse_br(Frame *f, Tag *tag);

/* parse_line.c */
void frame_parse_a(Frame *f, Tag *tag);
void frame_parse_font(Frame *f, Tag *tag);
void frame_parse_fontstyle(Frame *f, Tag *tag);

/* parse3.c */
void frame_parse_text(Frame *f, Tag *tag);

/* disp.c */
void frame_disp_init(Frame *f);
void frame_disp_all(Frame *f);
void frame_disp_area(Frame *f, int x, int y, int w, int h);

#endif
