/*
 *		XMulti Sample Module
 *		NADENADE MULTI
 */

#include <stdio.h>
#include <stdlib.h>

#include "XMaidP.h"
#include <X11/Xmu/Converters.h>
#include "xmaidpop.h"

#define WIDTH 		(xmw->core.width)
#define HEIGHT		(xmw->core.height)
#define MENUX		(xmw->xmaid.menu_x)
#define MENUY		(xmw->xmaid.menu_y)
#define MENUDX		(xmw->xmaid.menu_dx)
#define MENUDY		(xmw->xmaid.menu_dy)

#define EUCJP		"\x1b$)B"
#define MSG1		EUCJP "áĤΤá"
#define MSG2		EUCJP ""
#define CURSOR1 	"nade.xbm"
#define CURSOR2 	"nade2.xbm"

/* ʤǤʤȿϰ */
#define NADEX1		8	
#define NADEY1  	16
#define NADEX2  	88
#define NADEY2  	40 

/* ˥塼ȯݥ */
#define NADEMENUX   48
#define NADEMENUY   72
#define NADEMENUDX  24
#define NADEMENUDY  8

#define PATNUM 4

typedef enum {
	Normal,
	NadeNade,
	NadeNade2
} NadeState;

typedef struct NadeNadeData {
	char *names[PATNUM];
	int nx1, ny1;
	int nx2, ny2;
	int mx, my;
	int mdx, mdy;

	Animate *a[PATNUM];
	int mabataki;
	NadeState state;
	int cnt;
	Widget pop;
	Cursor cur[2];
} NadeNadeData;

#define offset(field)	XtOffsetOf(NadeNadeData, field)
static XtResource resources[] = {
	{
		"nx1", "X",
		XtRInt, sizeof(int),
		offset(nx1),
		XtRImmediate, (XtPointer)NADEX1
	},
	{
		"ny1", "Y",
		XtRInt, sizeof(int),
		offset(ny1),
		XtRImmediate, (XtPointer)NADEY1
	},
	{
		"nx2", "X",
		XtRInt, sizeof(int),
		offset(nx2),
		XtRImmediate, (XtPointer)NADEX2
	},
	{
		"ny2", "Y",
		XtRInt, sizeof(int),
		offset(ny2),
		XtRImmediate, (XtPointer)NADEY2
	},
	{
		"mx", "X",
		XtRInt, sizeof(int),
		offset(mx),
		XtRImmediate, (XtPointer)NADEMENUX
	},
	{
		"my", "Y",
		XtRInt, sizeof(int),
		offset(my),
		XtRImmediate, (XtPointer)NADEMENUY
	},
	{
		"mdx", "X",
		XtRInt, sizeof(int),
		offset(mdx),
		XtRImmediate, (XtPointer)NADEMENUDX
	},
	{
		"mdy", "Y",
		XtRInt, sizeof(int),
		offset(mdy),
		XtRImmediate, (XtPointer)NADEMENUDY
	},
	{
		"pattern0", "Pattern",
		XtRString, sizeof(String),
		offset(names[0]),
		XtRImmediate, (XtPointer)"multi_n0.gif"
	},
	{
		"pattern1", "Pattern",
		XtRString, sizeof(String),
		offset(names[1]),
		XtRImmediate, (XtPointer)"multi_n1.gif"
	},
	{
		"pattern2", "Pattern",
		XtRString, sizeof(String),
		offset(names[2]),
		XtRImmediate, (XtPointer)"multi_n2.gif"
	},
	{
		"pattern3", "Pattern",
		XtRString, sizeof(String),
		offset(names[3]),
		XtRImmediate, (XtPointer)"multi_n3.gif"
	}
};
#undef offset

#define ANIM (moddat->anim)
#define DATA (moddat->data)
#define XPOS (moddat->x)
#define YPOS (moddat->y)

/* ǡ */
static void
init(XMaidWidget xmw, XMaidModuleData *moddat)
{
	int i;
	FILE    *fp;
	Animate *a;
	NadeNadeData *p = DATA;

	for (i=0;i<4;i++) {
		p->a[i] = NULL;
		if ((fp = XMaidFileOpen(xmw, p->names[i], "r"))) {
			a = animate_new();
			if (!anim_gif_read_stream(a,fp))
				p->a[i] = a;
			else
				animate_delete(a);
			fclose(fp);
		} else {
			perror(p->names[i]);
			exit(1);
		}
	}

	p->mabataki = 0;
	p->state    = Normal;
	p->pop		= NULL;
	
	ANIM = p->a[0];

	/*  */
	{
		XrmValue from, to;
		Cursor cursor;
		to.size = sizeof(Cursor);
		to.addr = (XPointer)&cursor;

		from.addr = XMaidDataPath(xmw, CURSOR1);
		from.size = strlen((char *) from.addr) + 1;
		XtConvertAndStore((Widget)xmw, XtRString, &from, XtRColorCursor, &to);
		p->cur[0] = cursor;

		from.addr = XMaidDataPath(xmw, CURSOR2);
		from.size = strlen((char *) from.addr) + 1;
		XtConvertAndStore((Widget)xmw, XtRString, &from, XtRColorCursor, &to);
		p->cur[1] = cursor;
	}

	XtVaSetValues((Widget)xmw, XtNcursor, p->cur[0], NULL);

	MENUX  = p->mx;
	MENUY  = p->my;
	MENUDX = p->mdx;
	MENUDY = p->mdy;
}

/* ǡ */
static void
destroy(XMaidWidget xmw, XMaidModuleData *moddat)
{
	int i;
	NadeNadeData *p = DATA;
	for (i=0;i<4;i++)
		if (p->a[i])
			animate_delete(p->a[i]);
	if (p->pop)
		XtDestroyWidget(p->pop);
}

/* ܥ⥸塼 */
static int
move(XMaidWidget xmw, XMaidModuleData *moddat)
{
	NadeNadeData *p = DATA;

	switch (p->state) {
	case Normal:
		if (rand() % 10 == 0 && !p->mabataki) {
			p->mabataki = 1;
			ANIM = p->a[1];
			return 0;
		} else {
			p->mabataki = 0;
			ANIM = p->a[0];
		}
		break;
	case NadeNade:
		if (p->cnt == 0) {
			ANIM = p->a[2];
			p->pop = xmaidpop_open((Widget)xmw, 300, MSG1, 0);
		}
		if (p->cnt++ > 8) {
			p->cnt = 0;
			p->state = NadeNade2;
		}
		break;
	case NadeNade2:
		if (p->cnt == 0) {
			ANIM = p->a[3];
			if (p->pop)
				XtDestroyWidget(p->pop);
			p->pop = xmaidpop_open((Widget)xmw, 300, MSG2 , 0);
		}
		p->cnt++;
		break;
	}
	
	if (p->state == NadeNade || p->state == NadeNade2)
		XtVaSetValues((Widget)xmw, XtNcursor, p->cur[p->cnt & 1], NULL);

	return 200;
}

/* ٥ȥϥɥ */
static void
event(Widget w, XtPointer cl, XEvent *ev, Boolean *dis)
{
	NadeNadeData *p = ((XMaidModuleData*)cl)->data;

	switch (ev->type) {
	case ButtonPress:
		if (p->state == Normal &&
			ev->xbutton.button == Button1 && 
			ev->xbutton.x >= p->nx1 && ev->xbutton.x < p->nx2 &&
			ev->xbutton.y >= p->ny1 && ev->xbutton.y < p->ny2
			) {
			p->state = NadeNade;
			p->cnt   = 0;

			XtGrabPointer(w, False, ButtonReleaseMask,
						  GrabModeAsync, GrabModeAsync,
						  None, None, CurrentTime);
			
		}
		break;
	case ButtonRelease:
		if (p->state != Normal &&
			ev->xbutton.button == Button1) {
			p->state = Normal;
			if (p->pop)
				XtDestroyWidget(p->pop);
			p->pop = NULL;
			XtUngrabPointer(w, CurrentTime);
		}
		break;
	}
	*dis = TRUE;
}

XMaidModuleInfo nadenade_info = {
	"nadenade",					/* name                */
	sizeof(NadeNadeData),		/* data size           */
	NULL,						/* class initialize	   */
	init,						/* initialize          */
	NULL,						/* duplicate 		   */
	destroy,					/* destroy             */
	move,						/* move                */
	NULL,						/* after_move		   */
	event,						/* event handler       */
	ButtonPressMask |
	ButtonReleaseMask,			/* event mask          */
	FALSE,						/* override redirect   */
	TRUE,						/* mapped when managed */
	NULL,						/* options             */
	0,							/* options number      */
	resources,					/* resources           */
	XtNumber(resources),		/* resource numvber    */
	0							/* update_timing 	   */
};
