#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include <signal.h>

#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>

#include "XMaid.h"
#include "xmaidmsg.h"
#include "child.h"

static char *greeting[24] = {
/* 0 */
	"Фϡ٤ޤѤǤ",
	"Фϡ٤ޤѤǤ",
	"Фϡ٤ޤѤǤ",
	"ʤ᤯餪ŻǤ?",
	"ʤ᤯餪ŻǤ?",
	"ʤ᤯餪ŻǤ?",
/* 6 */
	"Ϥ褦ޤ",
	"Ϥ褦ޤ",
	"Ϥ褦ޤ",
	"Ϥ褦ޤ",
	"Ϥ褦ޤ",
	"Ϥ褦ޤ",
/* 12 */
	"ˤϡ",
	"ˤϡ",
	"ˤϡ",
	"ˤϡ",
	"ˤϡ",
	"ˤϡ",
/* 18 */
	"Фϡ",
	"Фϡ",
	"Фϡ",
	"Фϡ",
	"Фϡ",
	"Фϡ"
};

/* XXX */
static
void jisout(char *s, FILE *fp)
{
  int state=0;
  while (*s) {
      if (*s & 0x80) {
        if (state==0) {
          fputs("\x1b$B",fp);
          state = 1;
        }
        fputc(*s++ & 0x7f, fp);
        fputc(*s++ & 0x7f, fp);
      } else {
        if (state==1) {
          fputs("\x1b(B",fp);
          state = 0;
        }
        fputc(*s++, fp);
      }
  } 
  if (state==1)
    fputs("\x1b(B",fp);
}

static int 
extern_cmd(const char *cmd, FILE *fp)
{
    int             fds[2], check;
    pid_t           pid;
    int             wait_status;
    void            (*sig) ();
	int len;
	char buf[1024 + 1];

    sig = signal(SIGCHLD, SIG_IGN);

    if (pipe(fds)) {
        perror("pipe");
        return -1;
    }
    if ((pid = vfork()) < 0) {
        perror("fork");
        return -1;
    }

    /* ҥץ */
    if (pid == 0) {
		const char *p;
		close(fds[0]);
        close(1);
        dup(fds[1]);
        close(fds[1]);
        if ((p = strrchr(cmd, '/')) == NULL)
            p = cmd;
        else
            p++;
        execlp(cmd, p, NULL);
        perror("extern_cmd:execlp");
		exit(1);
    }

#if 0
	fprintf(stderr, "child pid:%d\n", pid);
#endif

    /* ƥץ */
	close(fds[1]);
	for(;;) {
		len = read(fds[0], buf, sizeof(buf)-1);
		if (len < 0) {
			perror("read");
			break;
		} else if (len == 0) {
			break;
		}
		buf[len] = '\0';
		jisout(buf, fp);
	}
	close(fds[0]);

    if (waitpid(pid, &wait_status, 0) < 0) {
        perror("wait");
        check = -1;
    } else {
        if (WIFEXITED(wait_status))
            check = WEXITSTATUS(wait_status);
        else
            check = -1;
    }
    signal(SIGCHLD, sig);

#if 0
	fprintf(stderr, "check: %d\n", check);
#endif

    return check;
}

static void
parse(char *str, FILE *fp)
{
	char *p, *q;
	while (str) {
		if ((p = strchr(str, '%'))) {
			if (p != str) {
				*p = '\0';
				jisout(str,fp);
			}
			p++;
			if (*p == '%') {
				jisout("%", fp);
				p++;
			} 
			if (*p == '!') {
				q = ++p;
				if ((p = strchr(q, ' '))) {
					*p = '\0';
					p++;
				} else if ((p = strchr(q, '\n'))) {
					*p = '\0';
					p++;
				}
				extern_cmd(q,fp);
			} else if (!strncmp(p, "greeting", 8)) {
				time_t t;
				struct tm *tmpt;
				p += 8;
				t = time(NULL);
				tmpt = localtime(&t);
				jisout(greeting[tmpt->tm_hour],fp);
			} else if (!strncmp(p, "date", 4)) {
				time_t t;
				struct tm *tmpt;
				char buf[200];
				char *weekday[] = { "", "", "", "", "", "", "" };
				p += 4;
				t = time(NULL);
				tmpt = localtime(&t);
				sprintf(buf, "%d%d(%s)", tmpt->tm_mon+1, tmpt->tm_mday,
						weekday[tmpt->tm_wday]);
				jisout(buf, fp);
			} else if (!strncmp(p, "childinfo", 9)) {
				p += 9;
				childinfo_show(fp);
			}
			str = p;
		} else {
			jisout(str, fp);
			break;
		}
	}
}		

#include "xmaidmsg.h"

void
xmaid_msginfo_entry_parsefile(XMaidMsgInfo *msg, char *name)
{
    int             fds[2];
    pid_t           pid;

    if (pipe(fds)) {
        perror("pipe");
        goto end;
    }
    if ((pid = fork()) < 0) {
        perror("fork");
        goto end;
    }

	/* ҥץ */
    if (pid  == 0) {
		char buf[1024];
		FILE *fp, *fp2;

		if ((fp = fopen(name, "r")) == NULL) {
			perror(name);
			exit(1);
		}	
		
		if ((fp2 = fdopen(fds[1], "w")) == NULL) {
			perror("fdopen");
			exit(1);
		}

		while (fgets(buf, sizeof(buf), fp)) {
			parse(buf, fp2);
		}
		exit(0);
	}

	/* ƥץ */
	close(fds[1]);
	xmaid_msginfo_entry_fd(msg, fds[0], name);
 end:
	return;
}
