#ifndef _xmaidmod_h_
#define _xmaidmod_h_

#include "XMaid.h"
#include "animate.h"

/*
   init		⥸塼뽪λ
   destroy	⥸塼
   update	ꤷַв or ̤ϸߤΥ˥᡼λ
   event	٥ȯ (EventHandler)
*/

typedef struct XMaidModuleData {
	void *data;		  	/* module infomation         */
	Animate *anim;		/* Current Animation pattern */
	Animate *prev_anim;
	int x, y;
	int xbak, ybak;
	Pixmap root_bak;
	Pixmap root_work;
	int level;
} XMaidModuleData;

typedef struct XMaidModuleInfo {
	char *name;		/* module's name */

	int   datasize;
	void  (*classinit)(void);

	void  (*init)(XMaidWidget xmw, XMaidModuleData *data);
	void  (*dup)(XMaidWidget xmw, XMaidModuleData *src, XMaidModuleData *data);
	void  (*destroy)(XMaidWidget xmw, XMaidModuleData *data);
	int   (*move)(XMaidWidget xmw, XMaidModuleData *data);
	void  (*after_move)(XMaidWidget xmw, XMaidModuleData *data);
	void  (*event)(Widget w, XtPointer cl, XEvent *ev, Boolean *);

	EventMask eventmask;
	int override;
	int map;
	XrmOptionDescRec *options;
	int noptions;
	XtResource *resources;
	int nresources;
	int update_timing;
} XMaidModuleInfo;

typedef struct XMaidModule {
	void *handler;
	XMaidModuleInfo *info;
} XMaidModule;

XMaidModule *xmaidmodule_new(void);
void xmaidmodule_delete(XMaidModule *p);
XMaidModuleData *xmaidmoduledata_new(void);
void xmaidmoduledata_delete(XMaidModuleData *p);

XMaidModule *xmaid_module_open(XMaidWidget xmw, const char *name);
XMaidModuleData *xmaid_moduledata_open(XMaidWidget xmw, 
									   XMaidModule *module, int num);

void xmaid_module_destroy(XMaidWidget xmw, XMaidModule *module);
void xmaid_moduledata_destroy(XMaidWidget xmw, XMaidModule *module,
							  XMaidModuleData *moddata);

void xmaid_module_init(XMaidWidget xmw, XMaidModule *module);
void xmaid_moduledata_init(XMaidWidget xmw, XMaidModule *module,
						   XMaidModuleData *moddata);
void xmaid_moduledata_dup(XMaidWidget xmw, XMaidModule *module, 
						  XMaidModuleData *src, XMaidModuleData *moddat);

extern XMaidModule     xmaid_default_module;
extern XMaidModuleData xmaid_default_moduledata;

#endif
