#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include "MsgPop.h"
#include "XMaidP.h"

static void
CloseHandler(XtPointer cl, XtIntervalId *id)
{
	Widget w = cl;
	XtDestroyWidget(w);
}

#define MENUX			(xmw->xmaid.menu_x)
#define MENUY			(xmw->xmaid.menu_y)
#define MENUDX			(xmw->xmaid.menu_dx)
#define MENUDY			(xmw->xmaid.menu_dy)

Widget
xmaidpop_open(Widget widget, u_int w,  char *str, int time)
{
	XMaidWidget xmw = (XMaidWidget)widget;
	Widget msgpop;
	msgpop = XtVaCreatePopupShell("msg",
								  msgPopWidgetClass, widget,
								  XtNwidth, w, 
								  XtNheight, 1, 
								  XtNx, xmw->core.x + MENUX,
								  XtNy, xmw->core.y + MENUY,
								  XtNdiffxpos, MENUDX,
								  XtNdiffypos, MENUDY,
								  XtNstring, str, 
								  NULL); 
	XtPopup(msgpop, FALSE);
	if (time)
		XtAppAddTimeOut(XtWidgetToApplicationContext(widget),
						time,  CloseHandler, (XtPointer)msgpop);
	return msgpop;
}
